function _define_property(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _object_spread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys2 = Object.keys(source);
    if (typeof Object.getOwnPropertySymbols === "function") {
      ownKeys2 = ownKeys2.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }
    ownKeys2.forEach(function(key) {
      _define_property(target, key, source[key]);
    });
  }
  return target;
}
function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) {
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }
    keys.push.apply(keys, symbols);
  }
  return keys;
}
function _object_spread_props(target, source) {
  source = source != null ? source : {};
  if (Object.getOwnPropertyDescriptors) {
    Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
  } else {
    ownKeys(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
import path from "path";
import { createMatchPath } from "@modern-js/utils/tsconfig-paths";
import { getUserAlias } from "@modern-js/utils";
var resolvePath = require("babel-plugin-module-resolver").resolvePath;
var defaultPaths = {
  "@": [
    "./src"
  ]
};
export var aliasPlugin = function(alias) {
  var absoluteBaseUrl = alias.absoluteBaseUrl, isTsPath = alias.isTsPath, _alias_isTsProject = alias.isTsProject, isTsProject = _alias_isTsProject === void 0 ? false : _alias_isTsProject;
  var mergedPaths = isTsPath ? alias.paths || {} : _object_spread({}, defaultPaths, alias.paths || {});
  var tsPaths = {};
  if (isTsProject) {
    tsPaths = getUserAlias(mergedPaths);
  }
  tsPaths = Object.keys(tsPaths).reduce(function(o, key) {
    if (typeof tsPaths[key] === "string") {
      return _object_spread_props(_object_spread({}, o), _define_property({}, "".concat(key), [
        tsPaths[key]
      ]));
    }
    return _object_spread_props(_object_spread({}, o), _define_property({}, "".concat(key), tsPaths[key]));
  }, {});
  var resolvePathFn = function(sourcePath, currentFile, opts) {
    if (sourcePath === "." || sourcePath === "./") {
      return sourcePath;
    }
    var matchPath = createMatchPath(absoluteBaseUrl, tsPaths, [
      "index"
    ]);
    var result = matchPath(sourcePath, void 0, void 0, [
      ".js",
      ".jsx",
      ".ts",
      ".tsx"
    ]);
    if (result) {
      var relativePath = path.relative(path.dirname(currentFile), path.dirname(result));
      var fileName = path.basename(result);
      var filePath = path.normalize("".concat(relativePath.length === 0 ? "." : relativePath, "/").concat(fileName)).replace(/\\/, "/");
      return filePath.startsWith(".") ? filePath : "./".concat(filePath);
    }
    return resolvePath(sourcePath, currentFile, opts);
  };
  var typescriptExts = [
    ".ts",
    ".tsx",
    ".js",
    ".jsx",
    ".es",
    ".es6",
    ".mjs"
  ];
  return [
    "babel-plugin-module-resolver",
    {
      root: absoluteBaseUrl,
      alias: mergedPaths,
      resolvePath: isTsPath ? resolvePathFn : void 0,
      extensions: isTsProject ? typescriptExts : void 0
    }
  ];
};
